<style scoped>

  i {
    margin-left: 5px;
  }

</style>

<template>

  <div>

    <ol class="breadcrumb">
      <li>
        <router-link to="/tasks">Tarefas</router-link>
      </li>
      <li v-if="isCreating" class="active">
        Incluir
      </li>
      <li v-if="isUpdating" class="active">
        Alterar
      </li>
    </ol>

    <form @submit.prevent="save()">

      <div class="form-container">

        <div class="row">

          <div v-if="isUpdating" class="form-group col-xs-6 col-sm-6 col-md-2 col-lg-1">
            <label>ID</label>
            <input type="text" class="form-control" readonly="readonly" v-model="task.id">
          </div>

          <div class="form-group col-xs-6 col-sm-6 col-md-3 col-lg-3">
            <label>Status</label>
            <app-task-status-icon :status="task.status"></app-task-status-icon>
            <select type="text" class="form-control" v-model="task.status">
              <option value="1">Pendente</option>
              <option value="2">Em andamento</option>
              <option value="3">Concluída</option>
              <option value="4">Cancelada</option>
            </select>
          </div>

        </div>

        <div class="row">

          <div class="form-group col-xs-12 col-sm-8 col-md-9 col-lg-10">
            <label class="control-label">Tarefa</label>
            <input type="text" class="form-control" v-model="task.description">
          </div>

          <div class="form-group col-xs-6 col-sm-4 col-md-3 col-lg-2">
            <label>Data Limite</label>
            <app-input-date id="input-task-deadline" @change-date="onChangeDate"></app-input-date>
          </div>

        </div>

      </div> <!-- form-container -->

      <div class="action-buttons">
        <div class="pull-left">
          <button type="submit" class="btn btn-success" :disabled="!canSave">
            <i class="fa fa-check"></i> Confirmar
          </button>
        </div>
        <div v-if="isUpdating" class="pull-right">
          <button type="button" class="btn btn-danger" @click="remove()">
            <i class="fa fa-times"></i> Excluir
          </button>
        </div>
      </div>

    </form>

  </div>

</template>

<script>

  import moment from "moment"
  import AppLocalStorage from "./../../services/app-local-storage"
  import TaskStatusIcon from "./../../components/task-status-icon.vue"
  import InputDate from "./../../components/input-date.vue"

  export default {

    data() {
      return {
        task: { id: 0, status: 1, description: "", deadline: moment().add(1, "days").format("DD/MM/YYYY") },
        isCreating: false,
        isUpdating: false,
      }
    },

    components: {
      appTaskStatusIcon: TaskStatusIcon,
      appInputDate: InputDate,
    },

    computed: {

      canSave() {

        return (this.task.description ? true : false)
      }
    },

    mounted() {

      this.isCreating = this.$route.params.id == "new" ? true : false
      this.isUpdating = !this.isCreating

      if (this.isUpdating)
        this.loadTask()

      $("#input-task-deadline").val(this.task.deadline).datepicker("update")  
    },

    methods: {

      loadTask() {

        let task = null
        const tasks = AppLocalStorage.get("tasks")

        tasks.forEach((element) => {

          if (element.id == this.$route.params.id)
            this.task = element
        })
      },

      save() {

        if (!this.canSave)
          return

        let tasks = AppLocalStorage.get("tasks")

        if (this.isCreating) {

          this.task.id = this.getNextId()

          tasks.push(this.task)

        } else {

          tasks.forEach((element, index) => {

            if (element.id == this.task.id) {
              tasks[index] = this.task
            }
          })
        }

        AppLocalStorage.set("tasks", tasks)

        this.$router.push("/tasks")
      },

      getNextId() {

        let maxId = 0
        let nextId = 0
        const tasks = AppLocalStorage.get("tasks")

        tasks.forEach((element) => {

          if (element.id > maxId)
            maxId = element.id
        })

        nextId = (maxId + 1)

        return nextId
      },

      remove() {

        let tasks = AppLocalStorage.get("tasks")
        let newTasks = []

        tasks.forEach((element, index) => {

          if (element.id != this.task.id) {
            newTasks.push(element)
          }
        })

        AppLocalStorage.set("tasks", newTasks)

        this.$router.push("/tasks")
      },

      onChangeDate(date) {

        this.task.deadline = date
      },
    }
  }

</script>
